#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>

#include "common.h"
#include "macros.h"
#include "failures.h"
#include "vm.h"
#include "vmlibcall.h"
#include "vmlibcalln.h"

static void vm_strlen(struct vm *machine)
{
	char str[STRING_LEN];

	vm_stack_get_string(machine, str);

	vm_stack_poke_int(machine, strlen(str));
}

static struct vm_libcall libcalls[] = {
	{ .name = "strlen",	.num = VM_STRLEN, .handler = vm_strlen },
	{ .name = NULL,		.num = 0,	  .handler = NULL }
};

void vm_libcall_init()
{
	unsigned int i;
	ret_t ret;

	for (i = 0; libcalls[i].name != NULL; i++) {
		ret = vm_libcall_register(&libcalls[i]);
		if (ret != ret_ok)
			xerror(1, "can't register `%s' library call",
					libcalls[i].name);
	}
}

